## libapache2-mod-tile 0.5

=== extra/Makefile ===
meta2tile: meta2tile.c 
	gcc -O3 -std=gnu99 -I../includes -I/usr/include  meta2tile.c -o meta2tile -lm
