=== debian/changelog ===
libapache2-mod-tile (0.5-2) unstable; urgency=medium

  * Team upload.

  [ Felix Delattre ]
  * Avoid circular dependency (Closes: #975073).

  [ Bas Couwenberg ]
  * Bump watch file version to 4.
  * Bump Standards-Version to 4.5.1, no changes.
  * Update packaging for Mapnik 3.1.
    (closes: #979585)

 -- Bas Couwenberg <sebastic@debian.org>  Mon, 11 Jan 2021 06:14:23 +0100

libapache2-mod-tile (0.5-1) unstable; urgency=medium

  * Use systemd-tmpfiles.
  * Removed deprecated dependency to mapnik 2.
  * Move from experimental to unstable.

 -- Felix Delattre <debian@xama.nu>  Fri, 23 Oct 2020 16:10:08 +0000

libapache2-mod-tile (0.5-1~exp1) experimental; urgency=medium

  [ Bas Couwenberg ]
  * Update packaging to incorporate Debian GIS changes.
  * Update Vcs-* URLs for Salsa.
  * Bump Standards-Version to 4.5.0, no changes.
  * Update watch file to limit matches to archive path.
  * Update gbp.conf to use --source-only-changes by default.
  * Add patch by Boris Shtrasman to use libiniparser package.
  * Drop renderd from Suggests, already part of Depends.
  * Remove renderd.conf before dh_install, custom config installed instead.
  * Fix install files.
  * Add dependency on lsb-base required by init script.
  * Add patch to use libjs-openlayers package.
  * Enable all hardening buildflags.
  * Add status option to init script.
  * Update libapache2-mod-tile packaging for 2.4.
  * Don't install site configuration.
  * Drop Name field from upstream metadata.
  * Bump debhelper compat to 10, changes:
    - Drop --parallel option, enabled by default
    - Don't explicitly enable autoreconf, enabled by default
    - Drop dh-autoreconf build dependency
  * Remove get-orig-source target from rules.
  * Update get-orig-source script for more robust git snapshots.
  * Add ${misc:Recommends} to renderd Recommends.

  [ Felix Delattre ]
  * Added information about patches forwarded to upstream.
  * Improved control file to responding to several lintian warnings.
  * Removed lintian override as it doesn't seem to be necessary anymore.
  * Added Documentation key and extended Description in systemd service file.
  * Adjust naming of config files following lintian.
  * Avoid recursive privilege change on directories during postinst.
  * Fixed check for enabled mod_tile during installation.
  * Moved config files in better subdirectory.
  * Small improvements in commenting and dependencies as web app.
  * Moved web app directory.
  * Make sure mod_tile is enabled on install of dependent packages.
  * Leave to the admin to enable munin plugins.
  * Change DEP-3 Forwarded to not-needed.
  * Removed Forwarded headers where there is Origin.
  * Realigned .install maintainer scripts.
  * Use Bug DEP-3 header to reference upstream reference.
  * Adhere to FHS 3.0 and use daemon under /run.
  * Updated patches to fit new upstream version.
  * Added README.Debian.
  * New upstream version 0.5
  * Initial package (Closes: #950904)

 -- Felix Delattre <debian@xama.nu>  Tue, 29 Sep 2020 15:23:23 +0000

libapache2-mod-tile (0.4-27~trusty1) trusty; urgency=low

  * Fixed a bug in passing internationalisation parameterisation to rendering slaves
  * Include replag script used in update-expire
  * Upstream 9d4e10e7c0ee5533d479f7365f135409e11b3250

 -- Kai Krueger <kakrueger@gmail.com>  Mon, 19 May 2014 00:00:00 +0000

libapache2-mod-tile (0.4-26~trusty1) trusty; urgency=low

  * Initial trusty package
  * Upstream 6c2cb243e4c8b047950ab8062cd66245f20a5d2f

 -- Kai Krueger <kakrueger@gmail.com>  Mon, 21 Apr 2014 00:00:00 +0000

libapache2-mod-tile (0.4-24~saucy5) saucy; urgency=low

  * Fix enabling tileserver_site apache2.4 now needs a .conf extension
  * Fix protocol v2/v3 compatibility issues.

 -- Kai Krueger <kakrueger@gmail.com>  Tue, 22 Oct 2013 00:00:00 +0000

libapache2-mod-tile (0.4-24~saucy3) saucy; urgency=low

  * Fix apache package dependencies for apache 2.4

 -- Kai Krueger <kakrueger@gmail.com>  Sun, 20 Oct 2013 00:00:00 +0000

libapache2-mod-tile (0.4-24~saucy2) saucy; urgency=low

  * Update package dependencies to recommend new carto style
  * Change renderd.conf to look for carto style by default

 -- Kai Krueger <kakrueger@gmail.com>  Sun, 20 Oct 2013 00:00:00 +0000

libapache2-mod-tile (0.4-24~saucy1) saucy; urgency=low

  * upstream version bd9739582a047b591c88e9f82955a74817fa54fe
  * fix debian dependencies on apache-dev

 -- Kai Krueger <kakrueger@gmail.com>  Sat, 19 Oct 2013 00:00:00 +0000

libapache2-mod-tile (0.4-23~saucy1) saucy; urgency=low

  * upstream version bd9739582a047b591c88e9f82955a74817fa54fe
  * initial package for saucy

 -- Kai Krueger <kakrueger@gmail.com>  Sun, 06 Oct 2013 00:00:00 +0000

libapache2-mod-tile (0.4-22~quantal3) quantal; urgency=low

  * Add another priority level for style rerendering
  * More fixes and improvements

 -- Kai Krueger <kakrueger@gmail.com>  Tue, 27 Aug 2013 00:00:00 +0000

libapache2-mod-tile (0.4-22~quantal2) quantal; urgency=low

  * Fix some issues when running renderd with more than 10 threads
  * Some additional munin scripts

 -- Kai Krueger <kakrueger@gmail.com>  Tue, 13 Aug 2013 00:00:00 +0000

libapache2-mod-tile (0.4-21~quantal1) quantal; urgency=low

  * Added support for zoom levels upto 20 in renderd

 -- Kai Krueger <kakrueger@gmail.com>  Fri, 31 May 2013 00:00:00 +0000

libapache2-mod-tile (0.4-20~quantal1) quantal; urgency=medium

  * Fixed thread stability issue
  * More changes

 -- Kai Krueger <kakrueger@gmail.com>  Thu, 30 May 2013 00:00:00 +0000

libapache2-mod-tile (0.4-19~quantal1) quantal; urgency=low

  * update from upstream ( b7cb20df4b9dff )

 -- Kai Krueger <kakrueger@gmail.com>  Tue, 14 May 2013 00:00:00 +0000

libapache2-mod-tile (0.4-18~quantal1) quantal; urgency=low

  * update from upstream ( 1341e129e5 )

 -- Kai Krueger <kakrueger@gmail.com>  Sat, 27 Apr 2013 00:00:00 +0000

libapache2-mod-tile (0.4-17~quantal1) quantal; urgency=low

  * update from upstream ( 54f668537a )

