=== debian/control ===
Source: libapache2-mod-tile
Maintainer: Debian GIS Project <pkg-grass-devel@lists.alioth.debian.org>
Uploaders: Felix Delattre <debian@xama.nu>
Section: science
Priority: optional
Build-Depends: debhelper (>= 10~),
               dh-apache2,
               apache2-dev,
               libcairo2-dev,
               libcurl4-gnutls-dev | libcurl-ssl-dev,
               libiniparser-dev,
               libmapnik-dev (>= 3.1)
Standards-Version: 4.5.1
Rules-Requires-Root: no
Vcs-Browser: https://salsa.debian.org/debian-gis-team/libapache2-mod-tile
Vcs-Git: https://salsa.debian.org/debian-gis-team/libapache2-mod-tile.git
Homepage: https://wiki.openstreetmap.org/wiki/Mod_tile

Package: libapache2-mod-tile
Architecture: any
Section: httpd
Depends: ${shlibs:Depends},
         ${misc:Depends}
Recommends: renderd | tirex,
            ${misc:Recommends}
Description: Apache module to deliver tiles created by renderd
 mod_tile is a system to serve raster tiles for example to use within a
 slippy map. It provides a dynamic combination of efficient caching and
 on the fly rendering. Due to its dynamic rendering, only a small
 fraction of overall tiles need to be kept on disk, reducing the
 resources required. At the same time, its caching strategy allows for a
 high performance serving and can support several thousand requests per
 second.
 .
 mod_tile was originally written for serving the tiles of the main
 OpenStreetMap map (Mapnik layer), but since is being used on a variety
 of different servers providing maps on top of OpenStreetMap data.
 .
 This package contains the Apache module that receives map tiles requests
 and satisfies them from tiles stored on disk, or queries a renderd
 instance to create them.

Package: renderd
Architecture: any
Section: utils
Depends: adduser,
         libapache2-mod-tile,
         lsb-base,
         ${shlibs:Depends},
         ${misc:Depends}
Recommends: osm2pgsql,
            ${misc:Recommends}
Description: Daemon that renders map tiles using mapnik
 mod_tile is a system to serve raster tiles for example to use within a
 slippy map. It provides a dynamic combination of efficient caching and
 on the fly rendering. Due to its dynamic rendering, only a small
 fraction of overall tiles need to be kept on disk, reducing the
 resources required. At the same time, its caching strategy allows for a
 high performance serving and can support several thousand requests per
 second.
 .
 This package contains the renderd daemon that creates "metatiles" for
 map tile requests issued by mod_tile using the mapnik library.
