## libapache2-mod-tile 0.6.1

=== debian/changelog ===
libapache2-mod-tile (0.6.1-2) unstable; urgency=medium

  * Team upload.

  [ Bas Couwenberg ]
  * Bump Standards-Version to 4.6.1, no changes.
  * Bump debhelper compat to 12, no changes.
  * Add ${misc:Pre-Depends} to renderd package.
  * Drop undefined substitution variables.

  [ Felix Delattre ]
  * Improve provided example configuration.

 -- Bas Couwenberg <sebastic@debian.org>  Thu, 01 Dec 2022 10:48:50 +0100

libapache2-mod-tile (0.6.1-1) unstable; urgency=medium

  [ Bas Couwenberg ]
  * Update watch file for GitHub URL changes.

  [ Felix Delattre ]
  * New upstream 0.6 release.
  * Update copyright owner information.
  * Rely on programms' configuration files from upstream.
  * New upstream 0.6.1 release.

 -- Felix Delattre <debian@xama.nu>  Tue, 17 Aug 2021 15:11:44 +0000
