=== debian/control ===
--- 
+++ 
@@ -3,14 +3,15 @@
 Uploaders: Felix Delattre <debian@xama.nu>
 Section: science
 Priority: optional
-Build-Depends: debhelper (>= 10~),
+Build-Depends: debhelper-compat (= 12),
                dh-apache2,
                apache2-dev,
                libcairo2-dev,
                libcurl4-gnutls-dev | libcurl-ssl-dev,
+               libglib2.0-dev,
                libiniparser-dev,
                libmapnik-dev (>= 3.1)
-Standards-Version: 4.5.1
+Standards-Version: 4.6.1
 Rules-Requires-Root: no
 Vcs-Browser: https://salsa.debian.org/debian-gis-team/libapache2-mod-tile
 Vcs-Git: https://salsa.debian.org/debian-gis-team/libapache2-mod-tile.git
@@ -21,8 +22,7 @@
 Section: httpd
 Depends: ${shlibs:Depends},
          ${misc:Depends}
-Recommends: renderd | tirex,
-            ${misc:Recommends}
+Recommends: renderd | tirex
 Description: Apache module to deliver tiles created by renderd
  mod_tile is a system to serve raster tiles for example to use within a
  slippy map. It provides a dynamic combination of efficient caching and
@@ -48,8 +48,7 @@
          lsb-base,
          ${shlibs:Depends},
          ${misc:Depends}
-Recommends: osm2pgsql,
-            ${misc:Recommends}
+Pre-Depends: ${misc:Pre-Depends}
 Description: Daemon that renders map tiles using mapnik
  mod_tile is a system to serve raster tiles for example to use within a
  slippy map. It provides a dynamic combination of efficient caching and
