=== debian/rules ===
#!/usr/bin/make -f

# DH_VERBOSE := 1

# Enable hardening build flags
export DEB_BUILD_MAINT_OPTIONS=hardening=+all

%:
	dh $@ --with apache2

override_dh_auto_test:
	dh_auto_test || echo "Ignoring test failures"
