## libapache2-mod-tile 0.7.0

=== debian/changelog ===
libapache2-mod-tile (0.7.0-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * Bump Standards-Version to 4.6.2, no changes.
  * Replace lsb-base dependency with sysvinit-utils (>= 3.05-4~).
  * Bump debhelper compat to 13.
  * Enable Salsa CI.
  * Switch to dh-sequence-*.
  * Update copyright file.
  * Drop virtualhost patch, included upstream.
  * Switch to cmake buildsystem.

 -- Bas Couwenberg <sebastic@debian.org>  Sat, 16 Mar 2024 11:30:09 +0100
