=== debian/control ===
--- 
+++ 
@@ -3,15 +3,19 @@
 Uploaders: Felix Delattre <debian@xama.nu>
 Section: science
 Priority: optional
-Build-Depends: debhelper-compat (= 12),
+Build-Depends: apache2,
+               apache2-dev,
+               cmake,
+               curl,
+               debhelper-compat (= 13),
                dh-apache2,
-               apache2-dev,
+               dh-sequence-apache2,
                libcairo2-dev,
                libcurl4-gnutls-dev | libcurl-ssl-dev,
                libglib2.0-dev,
                libiniparser-dev,
                libmapnik-dev (>= 3.1)
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Rules-Requires-Root: no
 Vcs-Browser: https://salsa.debian.org/debian-gis-team/libapache2-mod-tile
 Vcs-Git: https://salsa.debian.org/debian-gis-team/libapache2-mod-tile.git
@@ -45,7 +49,7 @@
 Section: utils
 Depends: adduser,
          libapache2-mod-tile,
-         lsb-base,
+         sysvinit-utils (>= 3.05-4),
          ${shlibs:Depends},
          ${misc:Depends}
 Pre-Depends: ${misc:Pre-Depends}
