=== debian/changelog ===
libapache2-mod-tile (0.7.1-2build3) plucky; urgency=medium

  * No-change rebuild for libiniparser4

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Fri, 01 Nov 2024 07:28:37 +0000

libapache2-mod-tile (0.7.1-2build2) oracular; urgency=medium

  * No-change rebuild for libmapnik4.0.1

 -- Sudip Mukherjee <sudipm.mukherjee@gmail.com>  Mon, 05 Aug 2024 17:31:49 +0100

libapache2-mod-tile (0.7.1-2build1) oracular; urgency=medium

  * Rebuild against new libmapnik4.0.0.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 19 Jun 2024 08:33:02 +0200

libapache2-mod-tile (0.7.1-2) unstable; urgency=medium

  * Team upload.
  * Add patch to fix FTBFS with Mapnik 4.0.0.

 -- Bas Couwenberg <sebastic@debian.org>  Mon, 17 Jun 2024 08:34:37 +0200

libapache2-mod-tile (0.7.1-1) unstable; urgency=medium

  * Team upload.
  * New upstream release.
  * Drop cmake-destdir.patch, applied upstream.

 -- Bas Couwenberg <sebastic@debian.org>  Sat, 16 Mar 2024 21:30:24 +0100

libapache2-mod-tile (0.7.0-2) unstable; urgency=medium

  * Team upload.
  * Add architecture-is-64-bit to build depends.

 -- Bas Couwenberg <sebastic@debian.org>  Sat, 16 Mar 2024 13:28:16 +0100
