=== debian/control ===
--- 
+++ 
@@ -5,6 +5,7 @@
 Priority: optional
 Build-Depends: apache2,
                apache2-dev,
+               architecture-is-64-bit,
                cmake,
                curl,
                debhelper-compat (= 13),
