## libapache2-mod-tile 0.8.0~beta

=== debian/changelog ===
libapache2-mod-tile (0.8.0~beta-1~exp1) experimental; urgency=medium

  * Team upload.
  * New upstream beta release.
  * Update copyright file.
  * Drop mapnik-4.0.patch, included upstream.

 -- Bas Couwenberg <sebastic@debian.org>  Thu, 20 Jun 2024 16:31:38 +0200
