=== debian/control ===
--- 
+++ 
@@ -19,7 +19,7 @@
 Standards-Version: 4.6.2
 Rules-Requires-Root: no
 Vcs-Browser: https://salsa.debian.org/debian-gis-team/libapache2-mod-tile
-Vcs-Git: https://salsa.debian.org/debian-gis-team/libapache2-mod-tile.git
+Vcs-Git: https://salsa.debian.org/debian-gis-team/libapache2-mod-tile.git -b experimental
 Homepage: https://wiki.openstreetmap.org/wiki/Mod_tile
 
 Package: libapache2-mod-tile
